/*
	ʥץ졪 - the number place puzzle game.
	Copyright (C) 2009 asari
	
	This program is free software; you can redistribute it	 and/or modify it under the terms of the GNU General P	ublic License as published by the Free Software Founda	tion; either version 3 of the License, or (at your opt	ion) any later version.
	
	This program is distributed in the hope that it will b	e useful, but WITHOUT ANY WARRANTY; without even the i	mplied warranty of MERCHANTABILITY or FITNESS FOR A PA	RTICULAR PURPOSE. See the GNU General Public License f	or more details.
	
	You should have received a copy of the GNU General Pub	lic License along with this program. If not, see <http	://www.gnu.org/licenses/>.
*/

#include <qmessagebox.h>
#include <qdialog.h>

#include "mainwindow.h"

Mainwindow::Mainwindow(QWidget *parent, const char *name)
		: QWidget(parent, name), buffer( 640, 480 ), screen( 640, 480 )
{
	codec = QTextCodec::codecForName("eucJP");
	window_title = "ʥץ졪 ver 0.4.0";
	setCaption(codec->toUnicode(window_title));

	QFont f("lcfont",18);
	setFont(f);

	menubar = new QMenuBar( this );
	m_tool = new QPopupMenu(this);
	m_tool->insertItem( codec->toUnicode(""), this, SLOT(slot_save_cleaner()), 0, 1 );
	m_tool->insertItem( codec->toUnicode("С"), this, SLOT(slot_version()), 0, 2 );
	m_game = new QPopupMenu(this);
	m_game->insertItem( codec->toUnicode("ơ"), this, SLOT(slot_load()), 0, 1 );
	m_game->insertItem( codec->toUnicode("ʤ"), this, SLOT(slot_restart()), 0, 2 );
	m_game->insertItem( codec->toUnicode(""), this, SLOT(slot_quitgame()), 0, 3 );

	m_menu = new QPopupMenu(this);
	m_menu->insertItem( codec->toUnicode("νλ"), qApp, SLOT(quit()), 0, 1 );
	
	menubar->insertItem( codec->toUnicode("˥塼"), m_menu );
	menubar->insertItem( codec->toUnicode(""), m_game );
	menubar->insertItem( codec->toUnicode("ġ"), m_tool );
	menubar->setSeparator( QMenuBar::InWindowsStyle );

	// QObject::connect( button, SIGNAL(clicked()), qApp, SLOT(quit()) );

	input = "";
	index = 0;
	pen_size = 0;
	newgame = 0;

	//QObject::connect( pen_type, SIGNAL(activated(int)), this, SLOT(slot_setPen()) );
	//QObject::connect( bar_type, SIGNAL(activated(int)), this, SLOT(slot_change_PenSize()) );

	if(this -> width() > this -> height()){
		v = (440-9*39)/2;
		w = (640-9*39)/2;
		chk = this -> width();
	} else {
		v = (600-9*39)/2;
		w = (480-9*39)/2;
		chk = this -> width();
	}

	// 񤭥ѥեΥ
	readSetupMap();

	// ֥եΥ
	load();

	// ơ
	select_stage = new SelectStage;

	// ɥ֤δƻ
    QTimer *timer = new QTimer(this);
    connect( timer, SIGNAL(timeout()), SLOT(slot_winmanager()) );
    timer->start( 100 );

	// 
	startup();
}



void Mainwindow::slot_save_cleaner()
{
	switch ( QMessageBox::information(0, codec->toUnicode("֥ǡν"), codec->toUnicode("֥ǡޤ\n\n\nʲΥǡޤ\n\nΥ"),QMessageBox::Yes,QMessageBox::No) ){
		case QMessageBox::Yes :
			save_cleaner();
			break;
		case QMessageBox::No :
			break;
	}
}



void Mainwindow::slot_load()
{
	switch ( QMessageBox::information(0, codec->toUnicode("Υ"), codec->toUnicode("Ϥޤ\n\n\nߤΥ֥ǡϥꥢޤ"),QMessageBox::Yes,QMessageBox::No) ){
		case QMessageBox::Yes :
			// select_stage = new SelectStage;
			select_stage -> exec();
			newgame = 1;
			break;
		case QMessageBox::No :
			break;
	}
}


void Mainwindow::slot_restart()
{
	switch ( QMessageBox::information(0, codec->toUnicode("Τʤ"), codec->toUnicode("ߤǽ餫ʤޤ\n\n\n֥ǡ⥯ꥢޤ"),QMessageBox::Yes,QMessageBox::No) ){
		case QMessageBox::Yes :
			int i, j;
			for( i=0; i<9; i++ ){
				for( j=0; j<9; j++ ){
					sheet[i][j] = 0;
				}
			}
			save(0);
			gameclear = 0;
			startup();
			break;
		case QMessageBox::No :
			break;
	}
}


void Mainwindow::mousePressEvent( QMouseEvent *e )
{
	if(gameclear == 0){
		mx = e -> QMouseEvent::x();
		my = e -> QMouseEvent::y();
		
		QPainter qp;
		qp.begin(&buffer);
		qp.setPen(QColor::QColor(170, 10, 10));
		qp.setBrush(QColor::QColor(170, 10, 10));
		qp.drawEllipse( mx, my, 1+pen_size*3, 1+pen_size*3);
		qp.end();
	
		int box_x, box_y, subox_x, subox_y, subox;
		QString sbox_x, sbox_y, ssubox;
		box_x = ((mx-w)-((mx-w)%39))/39;
		box_y = ((my-v)-((my-v)%39))/39;
		subox_x = (((mx-w)-((mx-w)%13))/13)%3+1;
		subox_y = (((my-v)-((my-v)%13))/13)%3;
		subox = subox_x + subox_y*3;
	
		sbox_x.setNum(box_x++, 10);
		sbox_y.setNum(box_y++, 10);
		ssubox.setNum(subox, 10);
	
		pre_box_x = box_x;
		pre_box_y = box_y;
		pre_input = subox;
		input = ssubox;
	
		bitBlt( this, 0, 0, &buffer, 0, 0, 640, 480 );
		
		mx_pre = mx;
		my_pre = my;
	}
}


void Mainwindow::mouseMoveEvent( QMouseEvent *e )
{
	if(gameclear == 0){
		mx = e -> QMouseEvent::x();
		my = e -> QMouseEvent::y();
		
		pen.setWidth(1+pen_size*3);
		pen.setColor( QColor::QColor(170, 10, 10) );
		
		QPainter qp;
		qp.begin(&buffer);
		qp.setPen(pen);
		qp.drawLine(mx_pre, my_pre, mx, my);
		qp.end();
		bitBlt( this, 0, 0, &buffer, 0, 0, 640, 480 );
	
		int box_x, box_y, subox_x, subox_y, subox;
		QString sbox_x, sbox_y, ssubox;
		box_x = ((mx-w)-((mx-w)%39))/39;
		box_y = ((my-v)-((my-v)%39))/39;
		subox_x = (((mx-w)-((mx-w)%13))/13)%3+1;
		subox_y = (((my-v)-((my-v)%13))/13)%3;
		subox = subox_x + subox_y*3;
	
		sbox_x.setNum(box_x++, 10);
		sbox_y.setNum(box_y++, 10);
		ssubox.setNum(subox, 10);
	
		if((box_x != pre_box_x) || (box_y != pre_box_y)){
			buffer = screen;
			pre_box_x = box_x;
			pre_box_y = box_y;
			
			input = ssubox;
			pre_input = subox;
		} else {
			if(pre_input != subox){
				pre_input = subox;
				input += ssubox;
			}
		}
		
		mx_pre = mx;
		my_pre = my;
	}
}


void Mainwindow::mouseReleaseEvent( QMouseEvent *e )
{
	if(gameclear == 0){
		mx = e -> QMouseEvent::x();
		my = e -> QMouseEvent::y();
	
		int box_x, box_y;
		box_x = ((mx-w)-((mx-w)%39))/39;
		box_y = ((my-v)-((my-v)%39))/39;
	
		int set_new = 0;
		if((((box_x>=0)&&(box_x<=8)) || ((box_y>=0)&&(box_y<=8))) && (quiz[box_x][box_y]==0)){
			int i = 0;
			while(word_input[i] != "0"){
				if(input == word_input[i]){
					sheet[box_x][box_y] = word_output[i];
					set_new = 1;
				}
				i++;
			}
		}
	
		buffer = screen;
		if(set_new == 0){
			bitBlt( this, 0, 0, &buffer, 0, 0, 640, 480 );
		} else {
			PaintSheet();
			if(AnsCheck()) GameClear();
		}
	
		// QMessageBox::information(0, codec->toUnicode("Test Mode"), codec->toUnicode("Input tag -> " + input),QMessageBox::Yes);
	}
}


void Mainwindow::paintEvent( QPaintEvent * )
{
	bitBlt( this, 0, 0, &buffer, 0, 0, 640, 480 );
}

void Mainwindow::PaintSheet()
{
	int i, j;
	QFont fcv("lcfont",36);

	// Ȥ
	QPainter qp;
	qp.begin(&buffer);

	buffer.fill( colorGroup().base() );

	pen.setColor( QColor::QColor(200, 200, 200) );
	qp.setPen(pen);
	for( x=0; x<27; x++ ){
		if(x%3!=0) qp.drawLine( w+x*13, v, w+x*13, v+39*9);
	}
	for( y=0; y<27; y++ ){
		if(y%3!=0) qp.drawLine( w, v+y*13, w+9*39, v+y*13);
	}

	pen.setColor( QColor::QColor(10, 160, 10) );
	qp.setPen(pen);
	for( x=0; x<10; x++ ){
		qp.drawLine( w+x*39, v, w+x*39, v+39*9);
	}
	for( y=0; y<10; y++ ){
		qp.drawLine( w, v+y*39, w+9*39, v+y*39);
	}

	pen.setColor( QColor::QColor(10, 10, 160) );
	qp.setPen(pen);
	for( x=0; x<10; x++ ){
		if(x%3==0){
			qp.drawLine( w+x*39, v, w+x*39, v+39*9);
			qp.drawLine( w+1+x*39, v, w+1+x*39, v+39*9);
		}
	}
	for( y=0; y<10; y++ ){
		if(y%3==0){
			qp.drawLine( w, v+y*39, w+9*39, v+y*39);
			qp.drawLine( w, v+1+y*39, w+9*39, v+1+y*39);
		}
	}

	for( i=0; i<9; i++ ){
		for( j=0; j<9; j++ ){
			if(sheet[i][j] != 0){
				QString num;
				if(sheet[i][j]==1) num="";
				if(sheet[i][j]==2) num="";
				if(sheet[i][j]==3) num="";
				if(sheet[i][j]==4) num="";
				if(sheet[i][j]==5) num="";
				if(sheet[i][j]==6) num="";
				if(sheet[i][j]==7) num="";
				if(sheet[i][j]==8) num="";
				if(sheet[i][j]==9) num="";

				if(quiz[i][j] != 0){
					qp.setPen( QColor::QColor( 0, 0, 0) );
				} else {
					qp.setPen( QColor::QColor( 120, 120, 120) );
				}

				// num.setNum(quiz[i][j], 10);
				qp.setFont(fcv);
				qp.drawText( w+2+i*39, v+(j+1)*39, codec->toUnicode(num));
			}
		}
	}

	qp.end();
	bitBlt( this, 0, 0, &buffer, 0, 0, 640, 480 );
	screen = buffer;
	screen_status = 1;
}



// ९ꥢβɽ
void Mainwindow::GameClear()
{
	// ʥפɽ
	QFont fcv2("lcfont",72);
	pen.setWidth(4);
	pen.setColor( QColor::QColor(170, 10, 10) );

	QPainter qp;
	qp.begin(&buffer);
	qp.setPen(pen);
	qp.drawEllipse(w+20, v+20, 300, 300);
	qp.setFont(fcv2);
	qp.drawText( w+5, v+100, codec->toUnicode("Clear!!"));
	qp.end();
	pen.setWidth(1);
	bitBlt( this, 0, 0, &buffer, 0, 0, 640, 480 );
	gameclear = 1;
	screen_status = 2;
}



// 󥵡å
int Mainwindow::AnsCheck()
{
	// ԡ󡢥ޥ¤줾죴
	int i, j, ans;
	int flag = 1;

	for(j=0; j<9; j++){
		ans = 0;
		for(i=0; i<9; i++){
			ans += sheet[i][j];
		}
		if(ans != 45){
			flag = 0;
			break;
		}
	}
	if(flag==0){
		save(flag);
		return 0;
	}

	for(i=0; i<9; i++){
		ans = 0;
		for(j=0; j<9; j++){
			ans += sheet[i][j];
		}
		if(ans != 45){
			flag = 0;
			break;
		}
	}
	if(flag==0){
		save(flag);
		return 0;
	}

	for(j=0; j<3; j++){
		for(i=0; i<3; i++){
			ans = 0;
			ans += sheet[i*3+0][j*3+0];
			ans += sheet[i*3+0][j*3+1];
			ans += sheet[i*3+0][j*3+2];
			ans += sheet[i*3+1][j*3+0];
			ans += sheet[i*3+1][j*3+1];
			ans += sheet[i*3+1][j*3+2];
			ans += sheet[i*3+2][j*3+0];
			ans += sheet[i*3+2][j*3+1];
			ans += sheet[i*3+2][j*3+2];
			if(ans != 45){
				flag = 0;
				break;
			}
		}
		if(flag == 0){
			break;
		}
	}

	save(flag);
	return flag;
}



// ơեθƤӽФʣãӣ֡
void Mainwindow::readMap()
{
	QString MapFile = dir + quiz_file + ".csv";
	
	QFile textfile( MapFile );
	if ( textfile.open(IO_ReadOnly) ){
		QTextStream t( &textfile );
		t.setCodec( codec );
		QString s;
		QStringList p;
		QString pl;
		int px = 0;
		int py = 0;
		
		while ( !t.eof() ) {
			s = t.readLine();
			p = QStringList::split(',', s, TRUE);
			px = 0;
			for ( QStringList::Iterator it = p.begin(); it != p.end(); ++it ) {
				if((py>=0) && (py<9)){
					pl = *it;
					quiz[px][py] = pl.toInt(0,10);
					px++;
				}
			}
			py++;
		}
		textfile.close();
	} else {
		QMessageBox::information(0, codec->toUnicode("Failed - Load"), codec->toUnicode("ɤ˼Ԥޤ\n\n"+MapFile+"\n\n¸ߤǧƤ"));
		gameclear = 1;
	}
}



// եθƤӽФʣãӣ֡
void Mainwindow::readSetupMap()
{
	QString MapFile = dir + "word_io.ini";
	
	QFile textfile( MapFile );
	if ( textfile.open(IO_ReadOnly) ){
		QTextStream t( &textfile );
		t.setCodec( codec );
		QString s;
		QStringList p;
		QString pl;
		int px = 0;
		int py = 0;
		
		while ( !t.eof() ) {
			s = t.readLine();
			p = QStringList::split(',', s, TRUE);
			px = 0;
			for ( QStringList::Iterator it = p.begin(); it != p.end(); ++it ) {
				pl = *it;
				if(px==0){
					word_input[py] = pl;
				} else if(px==1){
					word_output[py] = pl.toInt(0,10);
				}
				px++;
			}
			py++;
		}
		textfile.close();
	} else {
		QMessageBox::information(0, codec->toUnicode("Failed - Load"), codec->toUnicode("ɤ˼Ԥޤ\n\n"+MapFile+"\n\n¸ߤǧƤ\nץλޤ"));
		exit(0);
	}
}



void Mainwindow::slot_version()
{
	QMessageBox::about( this, codec->toUnicode("С"), codec->toUnicode(window_title + "\n\nCopyright (C) 2009 asari") );
}



void Mainwindow::save(int flag){
	int i, j;
	QString SaveFile = dir + "save.ini";
	QString st;
	QFile savefile( SaveFile );
	if ( savefile.open(IO_WriteOnly) ){
		QTextStream t( &savefile );
		t.setCodec( codec );
		t << quiz_file + "\n";
		st.setNum(flag, 10);
		t << st + "\n";

		for(j=0;j<9;j++){
			for(i=0;i<9;i++){
				if(quiz[i][j] == 0){
					st.setNum(sheet[i][j], 10);
				} else {
					st = "0";
				}
				if(i<8){
					t << st + ",";
					// printf(st + ",");
					// printf("%d,", sheet[i][j]);
				} else {
					t << st + "\n";
					// printf(st + "\n");
					// printf("%d\n", sheet[i][j]);
				}
			}
		}
		// printf("\n\n");

		savefile.close();
	}else{
		QMessageBox::information(0, codec->toUnicode("Failed - Save(save.ini)"), codec->toUnicode("֤˼Ԥޤ\n\n/home/zaurus/yuruyuru\n\nե¸ߤǧƤ"));
	}
}



// ֥եθƤӽФ
void Mainwindow::load()
{
	QString MapFile = dir + "save.ini";
	
	QFile textfile( MapFile );
	if ( textfile.open(IO_ReadOnly) ){
		QTextStream t( &textfile );
		t.setCodec( codec );
		QString s;
		QStringList p;
		QString pl;
		int px = 0;
		int py = 0;
		
		while ( !t.eof() ) {
			s = t.readLine();
			p = QStringList::split(',', s, TRUE);
			px = 0;
			if(py==0){
				quiz_file = s;
			}
			if(py==1){
				gameclear = s.toInt(0,10);
			}
			for ( QStringList::Iterator it = p.begin(); it != p.end(); ++it ) {
				if((py>=2) && (py<2+9)){
					pl = *it;
					sheet[px][py-2] = pl.toInt(0,10);
					px++;
				}
			}
			py++;
		}
		textfile.close();
	} else {
		gameclear = 1;
		QMessageBox::information(0, codec->toUnicode("Failed - Load"), codec->toUnicode("ɤ˼Ԥޤ\n\n֥ǡޤ"));
		save_cleaner();
	}
}



// 
void Mainwindow::startup()
{
	buffer.fill( colorGroup().base() );
	setBackgroundMode( QWidget::PaletteBase );

	if(gameclear == 0){
		// Υ
		readMap();
	
		int i, j;
	
		for( i=0; i<9; i++ ){
			for( j=0; j<9; j++ ){
				if(quiz[i][j] != 0) sheet[i][j] = quiz[i][j];
				// printf("%10d,", sheet[i][j]);
			}
			// printf("\n");
		}
		// printf("\n");

		// ̤Ǥϥ˥塼ΰͭ
		m_game->setItemEnabled( 2, TRUE);
		m_game->setItemEnabled( 3, TRUE);

		// ̤Ǥϥġ˥塼ΰ̵
		m_tool->setItemEnabled( 1, FALSE);
	
		PaintSheet();
	} else {
		main_screen();
	}
}



// ֥ǡν
void Mainwindow::save_cleaner()
{
	int i, j;
	for( i=0; i<9; i++ ){
		for( j=0; j<9; j++ ){
			sheet[i][j] = 0;
		}
	}
	quiz_file = "quiz0000";
	save(1);

	QMessageBox::about( this, codec->toUnicode("νλѹ"), codec->toUnicode("٤ƤΥ֥ǡޤ\nöλޤ") );
	exit(0);
}



// ȥ
void Mainwindow::main_screen()
{
	int i, j;
	QFont fcv("lcfont",36);

	// Ȥ
	QPainter qp;
	qp.begin(&buffer);

	buffer.fill( colorGroup().base() );

	pen.setColor( QColor::QColor(200, 200, 200) );
	qp.setPen(pen);
	for( x=0; x<27; x++ ){
		if(x%3!=0) qp.drawLine( w+x*13, v, w+x*13, v+39*9);
	}
	for( y=0; y<27; y++ ){
		if(y%3!=0) qp.drawLine( w, v+y*13, w+9*39, v+y*13);
	}

	pen.setColor( QColor::QColor(10, 160, 10) );
	qp.setPen(pen);
	for( x=0; x<10; x++ ){
		qp.drawLine( w+x*39, v, w+x*39, v+39*9);
	}
	for( y=0; y<10; y++ ){
		qp.drawLine( w, v+y*39, w+9*39, v+y*39);
	}

	pen.setColor( QColor::QColor(10, 10, 160) );
	qp.setPen(pen);
	for( x=0; x<10; x++ ){
		if(x%3==0){
			qp.drawLine( w+x*39, v, w+x*39, v+39*9);
			qp.drawLine( w+1+x*39, v, w+1+x*39, v+39*9);
		}
	}
	for( y=0; y<10; y++ ){
		if(y%3==0){
			qp.drawLine( w, v+y*39, w+9*39, v+y*39);
			qp.drawLine( w, v+1+y*39, w+9*39, v+1+y*39);
		}
	}

	qp.setPen( QColor::QColor( 120, 120, 120) );
	qp.setFont(fcv);

	i=1; j=1;
	qp.drawText( w+2+i*39, v+(j+1)*39, codec->toUnicode(""));
	i=2; j=2;
	qp.drawText( w+2+i*39, v+(j+1)*39, codec->toUnicode(""));
	i=3; j=1;
	qp.drawText( w+2+i*39, v+(j+1)*39, codec->toUnicode(""));
	i=4; j=2;
	qp.drawText( w+2+i*39, v+(j+1)*39, codec->toUnicode(""));
	i=3; j=3;
	qp.drawText( w+2+i*39, v+(j+1)*39, codec->toUnicode(""));
	i=4; j=4;
	qp.drawText( w+2+i*39, v+(j+1)*39, codec->toUnicode(""));
	i=5; j=3;
	qp.drawText( w+2+i*39, v+(j+1)*39, codec->toUnicode(""));
	i=6; j=4;
	qp.drawText( w+2+i*39, v+(j+1)*39, codec->toUnicode(""));
	i=7; j=3;
	qp.drawText( w+2+i*39, v+(j+1)*39, codec->toUnicode(""));
	
	qp.end();
	bitBlt( this, 0, 0, &buffer, 0, 0, 640, 480 );
	screen = buffer;

	// ȥ̤Ǥϥ˥塼ΰ̵
	m_game->setItemEnabled( 2, FALSE);
	m_game->setItemEnabled( 3, FALSE);

	// ȥ̤Ǥϥġ˥塼ΰͭ
	m_tool->setItemEnabled( 1, TRUE);

	screen_status = 0;
}



// 
void Mainwindow::slot_quitgame()
{
	switch ( QMessageBox::information(0, codec->toUnicode(""), codec->toUnicode("ߤ򤢤ޤ\n\n\n֥ǡϥꥢޤ"),QMessageBox::Yes,QMessageBox::No) ){
		case QMessageBox::Yes :
			gameclear = 1;
			save(1);
			main_screen();
			break;
		case QMessageBox::No :
			break;
	}
}



// ɥ֤δƻ
void Mainwindow::slot_winmanager()
{
	if(chk != this -> width()){
		if(this -> width() > this -> height()){
			v = (440-9*39)/2;
			w = (640-9*39)/2;
			chk = this -> width();
		} else {
			v = (600-9*39)/2;
			w = (480-9*39)/2;
			chk = this -> width();
		}
	
		if(screen_status >= 1){
			PaintSheet();
			if(screen_status == 2) GameClear();
		} else {
			main_screen();
		}
	}

	if( newgame==1 && select_stage->result()==1 ){
		newgame = 0;
		int i, j;
		for( i=0; i<9; i++ ){
			for( j=0; j<9; j++ ){
				sheet[i][j] = 0;
			}
		}
		save(0);
		gameclear = 0;
		startup();
	}
}
