/*
	ʥץ졪 - the number place puzzle game.
	Copyright (C) 2009 asari
	
	This program is free software; you can redistribute it	 and/or modify it under the terms of the GNU General P	ublic License as published by the Free Software Founda	tion; either version 3 of the License, or (at your opt	ion) any later version.
	
	This program is distributed in the hope that it will b	e useful, but WITHOUT ANY WARRANTY; without even the i	mplied warranty of MERCHANTABILITY or FITNESS FOR A PA	RTICULAR PURPOSE. See the GNU General Public License f	or more details.
	
	You should have received a copy of the GNU General Pub	lic License along with this program. If not, see <http	://www.gnu.org/licenses/>.
*/

#include <qmessagebox.h>

#include "selectstage.h"

SelectStage::SelectStage(QWidget *parent, const char *name, bool modal=TRUE)
		: QDialog(parent, name)
{
	codec = QTextCodec::codecForName("eucJP");
	setCaption(codec->toUnicode("ơ"));
	resize(365, 200);

	QFont f("lcfont",18);
	setFont(f);

	QString comp_quiz_file = quiz_file + ".csv";
	int comp_quiz_id = 0;

	list = new QListBox(this);
	d.setPath( dir );
	d.setSorting ( QDir::Name );
	d.setNameFilter("quiz****.csv");
	for ( uint i=1; i<=d.count(); i++ ){
		list -> insertItem ( codec->toUnicode(d[i-1]), i );
		if(comp_quiz_file == d[i-1]) comp_quiz_id = i - 1;
	}
	list -> setSelected(comp_quiz_id, TRUE);
	list -> resize(150,180);

	repaint();
	QObject::connect( list, SIGNAL(highlighted(int)), this, SLOT(slot_setQuiz()) );
}



void SelectStage::slot_setQuiz(){
	quiz_file = d[list->currentItem()];
	quiz_file = quiz_file.left(8);
}



void SelectStage::paintEvent( QPaintEvent * )
{
	QPainter qp(this);
	QFont fc("lcfont",12);
	qp.setFont(fc);
	QBrush qb( QColor::QColor( 255, 255, 255), QBrush::SolidPattern );
	qp.fillRect(155,10,210,190,qb);
	qp.setPen( QColor::QColor( 40, 40, 40) );
	qp.drawText(160,30,codec->toUnicode("ץ쥤  ----"));
	qp.drawText(160,50,codec->toUnicode("ǽץ쥤  ----/--/-- --:--:--"));

	// Ȥ
	int w=195;
	int v=70;
	int x,y;

	qp.setPen( QColor::QColor( 10, 160, 10) );
	for( x=0; x<10; x++ ){
		qp.drawLine( w+x*13, v, w+x*13, v+13*9);
	}
	for( y=0; y<10; y++ ){
		qp.drawLine( w, v+y*13, w+9*13, v+y*13);
	}

	qp.setPen( QColor::QColor( 10, 10, 160) );
	for( x=0; x<10; x++ ){
		if(x%3==0){
			qp.drawLine( w+x*13, v, w+x*13, v+13*9);
		}
	}
	for( y=0; y<10; y++ ){
		if(y%3==0){
			qp.drawLine( w, v+y*13, w+9*13, v+y*13);
		}
	}

	/*
	for( i=0; i<9; i++ ){
		for( j=0; j<9; j++ ){
			if(sheet[i][j] != 0){
				QString num;
				if(sheet[i][j]==1) num="";
				if(sheet[i][j]==2) num="";
				if(sheet[i][j]==3) num="";
				if(sheet[i][j]==4) num="";
				if(sheet[i][j]==5) num="";
				if(sheet[i][j]==6) num="";
				if(sheet[i][j]==7) num="";
				if(sheet[i][j]==8) num="";
				if(sheet[i][j]==9) num="";

				if(quiz[i][j] != 0){
					qp.setPen( QColor::QColor( 0, 0, 0) );
				} else {
					qp.setPen( QColor::QColor( 120, 120, 120) );
				}

				// num.setNum(quiz[i][j], 10);
				qp.setFont(fcv);
				qp.drawText( w+2+i*39, v+(j+1)*39, codec->toUnicode(num));
			}
		}
	}
	*/
}
